git: f38ffa0f96c2 - main - net/haproxy: rename to haproxy26 in preparation for updating haproxy to version 2.7

From: Dmitry Sivachenko <demon_at_FreeBSD.org>
Date: Tue, 24 Jan 2023 10:14:49 UTC
The branch main has been updated by demon:

URL: https://cgit.FreeBSD.org/ports/commit/?id=f38ffa0f96c2d704f6f04c1877de152d7ff6d2e1

commit f38ffa0f96c2d704f6f04c1877de152d7ff6d2e1
Author:     Dmitry Sivachenko <demon@FreeBSD.org>
AuthorDate: 2023-01-24 10:10:53 +0000
Commit:     Dmitry Sivachenko <demon@FreeBSD.org>
CommitDate: 2023-01-24 10:14:32 +0000

    net/haproxy: rename to haproxy26 in preparation for updating haproxy to version 2.7
---
 net/Makefile                           |   1 +
 net/haproxy26/Makefile                 |  75 +++++++++++++++++++
 net/haproxy26/distinfo                 |   3 +
 net/haproxy26/files/haproxy.in         | 130 +++++++++++++++++++++++++++++++++
 net/haproxy26/files/patch-src_cpuset.c |  14 ++++
 net/haproxy26/pkg-descr                |   4 +
 net/haproxy26/pkg-plist                | 113 ++++++++++++++++++++++++++++
 7 files changed, 340 insertions(+)

diff --git a/net/Makefile b/net/Makefile
index ee630ece3f1d..8d6100956692 100644
--- a/net/Makefile
+++ b/net/Makefile
@@ -246,6 +246,7 @@
     SUBDIR += haproxy23
     SUBDIR += haproxy24
     SUBDIR += haproxy25
+    SUBDIR += haproxy26
     SUBDIR += hblock
     SUBDIR += hexinject
     SUBDIR += hlmaster
diff --git a/net/haproxy26/Makefile b/net/haproxy26/Makefile
new file mode 100644
index 000000000000..04b2809bb3d6
--- /dev/null
+++ b/net/haproxy26/Makefile
@@ -0,0 +1,75 @@
+PORTNAME=	haproxy
+DISTVERSION=	2.6.8
+CATEGORIES=	net www
+PKGNAMESUFFIX=	26
+MASTER_SITES=	http://www.haproxy.org/download/2.6/src/
+
+MAINTAINER=	demon@FreeBSD.org
+COMMENT=	Reliable, high performance TCP/HTTP load balancer
+WWW=		https://www.haproxy.org
+
+LICENSE=	GPLv2 LGPL21
+LICENSE_COMB=	multi
+
+FLAVORS=	default lua
+FLAVOR?=	${FLAVORS:[1]}
+
+USES=		compiler:c++11-lang cpe gmake
+USE_RC_SUBR=	haproxy
+
+default_CONFLICTS_INSTALL=	haproxy-lua
+lua_CONFLICTS_INSTALL=		haproxy
+lua_PKGNAMESUFFIX=		26-lua
+
+CONFLICTS_INSTALL=	haproxy haproxy-devel haproxy17 haproxy18 haproxy20 haproxy22 haproxy23 haproxy24 haproxy25
+
+ALL_TARGET=	all admin/halog/halog
+MAKE_ARGS=	TARGET=freebsd DEFINE=-DFREEBSD_PORTS USE_GETADDRINFO=1 \
+		USE_ZLIB=1 USE_CPU_AFFINITY=1 USE_ACCEPT4=1 \
+		CC="${CC}" DEBUG_CFLAGS="" CPU_CFLAGS="${CFLAGS}" \
+		${MAKE_ARGS_${ARCH}}
+
+MAKE_ARGS_i386=	USE_LIBATOMIC=
+MAKE_ARGS_powerpc=	USE_LIBATOMIC=
+
+OPTIONS_DEFINE=		DOCS EXAMPLES LUA OPENSSL DEVICEATLAS PROMEX
+OPTIONS_RADIO=		PCRE
+OPTIONS_RADIO_PCRE=	DPCRE DPCRE2 SPCRE SPCRE2
+DPCRE_DESC=		Link pcre(1) dynamically
+DPCRE2_DESC=		Link pcre2 dynamically
+SPCRE_DESC=		Link pcre(1) statically
+SPCRE2_DESC=		Link pcre2 statically
+DEVICEATLAS_DESC=	DeviceAtlas Device Detection support
+PROMEX_DESC=		Enable Prometheus exporter
+OPTIONS_DEFAULT=	DPCRE2 OPENSSL PROMEX
+
+DPCRE_LIB_DEPENDS=	libpcre.so:devel/pcre
+DPCRE_MAKE_ARGS=	USE_PCRE=1 USE_PCRE_JIT=1
+DPCRE2_LIB_DEPENDS=	libpcre2-8.so:devel/pcre2
+DPCRE2_MAKE_ARGS=	USE_PCRE2=1 USE_PCRE2_JIT=1
+SPCRE_BUILD_DEPENDS=	${LOCALBASE}/lib/libpcre.a:devel/pcre
+SPCRE_MAKE_ARGS=	USE_PCRE=1 USE_STATIC_PCRE=1 USE_PCRE_JIT=1
+SPCRE2_BUILD_DEPENDS=	${LOCALBASE}/lib/libpcre2-8.a:devel/pcre2
+SPCRE2_MAKE_ARGS=	USE_PCRE2=1 USE_STATIC_PCRE2=1 USE_PCRE2_JIT=1
+DEVICEATLAS_LIB_DEPENDS=	libda.so:net/deviceatlas-enterprise-c
+DEVICEATLAS_MAKE_ARGS=		USE_DEVICEATLAS=1 DEVICEATLAS_LIB=${LOCALBASE}/lib DEVICEATLAS_INC=${LOCALBASE}/include
+PROMEX_MAKE_ARGS=	USE_PROMEX=1
+OPENSSL_USES=		ssl
+OPENSSL_MAKE_ARGS=	USE_OPENSSL=1 SSL_LIB=${OPENSSLLIB} SSL_INC=${OPENSSLINC}
+LUA_USES=		lua:53
+LUA_MAKE_ARGS=		USE_LUA=1 LUA_INC=${LUA_INCDIR} LUA_LIB=${LUA_LIBDIR} LUA_LIB_NAME=lua-${LUA_VER}
+
+.if ${FLAVOR:U} == lua
+OPTIONS_DEFAULT+=	LUA
+.endif
+
+do-install:
+	${INSTALL_PROGRAM} ${WRKSRC}/haproxy ${STAGEDIR}${PREFIX}/sbin/
+	${INSTALL_PROGRAM} ${WRKSRC}/admin/halog/halog ${STAGEDIR}${PREFIX}/sbin/
+	${INSTALL_MAN} ${WRKSRC}/doc/haproxy.1 ${STAGEDIR}${MAN1PREFIX}/man/man1
+	${MKDIR} ${STAGEDIR}${DOCSDIR}
+	(cd ${WRKSRC}/doc/ && ${COPYTREE_SHARE} \* ${STAGEDIR}${DOCSDIR})
+	${MKDIR} ${STAGEDIR}${EXAMPLESDIR}
+	(cd ${WRKSRC}/examples/ && ${COPYTREE_SHARE} \* ${STAGEDIR}${EXAMPLESDIR})
+
+.include <bsd.port.mk>
diff --git a/net/haproxy26/distinfo b/net/haproxy26/distinfo
new file mode 100644
index 000000000000..b3a26c636bf3
--- /dev/null
+++ b/net/haproxy26/distinfo
@@ -0,0 +1,3 @@
+TIMESTAMP = 1674553743
+SHA256 (haproxy-2.6.8.tar.gz) = a02ad64550dd30a94b25fd0e225ba699649d0c4037bca3b36b20e8e3235bb86f
+SIZE (haproxy-2.6.8.tar.gz) = 4041517
diff --git a/net/haproxy26/files/haproxy.in b/net/haproxy26/files/haproxy.in
new file mode 100644
index 000000000000..e9eb2147c412
--- /dev/null
+++ b/net/haproxy26/files/haproxy.in
@@ -0,0 +1,130 @@
+#!/bin/sh
+
+# PROVIDE: haproxy
+# REQUIRE: DAEMON LOGIN
+# KEYWORD: shutdown
+
+#
+# Add the following lines to /etc/rc.conf to enable haproxy:
+#
+# haproxy_enable (bool):	default: "NO"
+#				Set to "YES" to enable haproxy
+# haproxy_pidfile (str):	default: /var/run/haproxy.pid
+#				Set to the full path of the pid file
+# haproxy_config (str):		default: %%PREFIX%%/etc/haproxy.conf
+#				Set to the full path of the config file
+# haproxy_flags (str):		default: Autogenerated using pidfile and config options
+#				Set to override with your own options
+# haproxy_profiles (str):	default: empty
+# Set to space-separated list of profiles: for each profile separate haproxy
+# process will be spawned, with haproxy-${profile}.conf config file.
+# You can override default pidfile and config file for each profile with
+# haproxy_${profile}_config and haproxy_${profile}_pidfile.
+
+. /etc/rc.subr
+
+name="haproxy"
+rcvar=haproxy_enable
+command="%%PREFIX%%/sbin/haproxy"
+extra_commands="reload configtest hardstop hardreload softreload"
+reload_cmd="haproxy_reload"
+hardreload_cmd="haproxy_reload"
+hardreload_precmd="def_hardreload_option"
+softreload_cmd="haproxy_reload"
+softreload_precmd="def_softreload_option"
+stop_cmd="haproxy_stop"
+hardstop_cmd="haproxy_stop"
+hardstop_precmd="def_hardstop_signal"
+
+: ${haproxy_enable:="NO"}
+: ${haproxy_config:="%%PREFIX%%/etc/${name}.conf"}
+: ${haproxy_socket:="/var/run/${name}/socket"}
+pidfile=${haproxy_pidfile:-"/var/run/haproxy.pid"}
+
+def_hardreload_option()
+{
+    reload_opt="-st"
+}
+
+def_softreload_option()
+{
+    reload_opt="-x ${haproxy_socket} -sf"
+}
+
+def_hardstop_signal()
+{
+    sig_stop="TERM"
+}
+
+load_rc_config $name
+
+is_valid_profile() {
+    local profile
+    for profile in $haproxy_profiles; do
+        if [ "$profile" = "$1" ]; then
+            return 0
+        fi
+    done
+    return 1
+}
+
+if [ -n "$2" ]; then
+    profile=$2
+    if ! is_valid_profile $profile; then
+        echo "$0: no such profile ($profile) defined in ${name}_profiles."
+        exit 1
+    fi
+    eval haproxy_config="\${haproxy_${profile}_config:-%%PREFIX%%/etc/haproxy-${profile}.conf}"
+    eval pidfile="\${haproxy_${profile}_pidfile:-/var/run/haproxy-${profile}.pid}"
+else
+    if [ "x${haproxy_profiles}" != "x" -a "x$1" != "x" ]; then
+        for profile in ${haproxy_profiles}; do
+            echo "===> ${name} profile: ${profile}"
+            %%PREFIX%%/etc/rc.d/haproxy $1 ${profile}
+            retcode="$?"
+            if [ ${retcode} -ne 0 ]; then
+                failed="${profile} (${retcode}) ${failed:-}"
+            else
+                success="${profile} ${success:-}"
+            fi
+        done
+        exit 0
+    fi
+fi
+
+: ${haproxy_flags:="-q -f ${haproxy_config} -p ${pidfile}"}
+configtest_cmd="$command -c -f $haproxy_config"
+start_precmd="$command -q -c -f $haproxy_config"
+required_files=$haproxy_config
+sig_stop=SIGUSR1
+reload_opt="-sf"
+
+haproxy_reload()
+{
+	${command} -q -c -f ${haproxy_config}
+	if [ $? -ne 0 ]; then
+	    err 1 "Error found in ${haproxy_config} - not reloading current process!"
+	fi
+	rc_pid=$(check_pidfile ${pidfile} ${command})
+	if [ $rc_pid ]; then
+		${command} ${haproxy_flags} $reload_opt $(cat ${pidfile})
+	else
+		_run_rc_notrunning
+		return 1
+	fi
+}
+
+haproxy_stop()
+{
+	rc_pid=$(check_pidfile ${pidfile} ${command})
+	if [ $rc_pid ]; then
+		rc_pid=$(cat ${pidfile})
+		kill -$sig_stop $rc_pid
+		wait_for_pids $rc_pid
+	else
+		_run_rc_notrunning
+		return 1
+	fi
+}
+
+run_rc_command "$1"
diff --git a/net/haproxy26/files/patch-src_cpuset.c b/net/haproxy26/files/patch-src_cpuset.c
new file mode 100644
index 000000000000..42f04b37e6f6
--- /dev/null
+++ b/net/haproxy26/files/patch-src_cpuset.c
@@ -0,0 +1,14 @@
+--- src/cpuset.c.orig	2021-12-23 16:47:51 UTC
++++ src/cpuset.c
+@@ -53,7 +53,11 @@ void ha_cpuset_and(struct hap_cpuset *dst, const struc
+ 	CPU_AND(&dst->cpuset, &dst->cpuset, &src->cpuset);
+ 
+ #elif defined(CPUSET_USE_FREEBSD_CPUSET)
++#if defined(CPU_ALLOC)
++	CPU_AND(&dst->cpuset, &dst->cpuset, &src->cpuset);
++#else
+ 	CPU_AND(&dst->cpuset, &src->cpuset);
++#endif
+ 
+ #elif defined(CPUSET_USE_ULONG)
+ 	dst->cpuset &= src->cpuset;
diff --git a/net/haproxy26/pkg-descr b/net/haproxy26/pkg-descr
new file mode 100644
index 000000000000..da6bc0e2c38c
--- /dev/null
+++ b/net/haproxy26/pkg-descr
@@ -0,0 +1,4 @@
+HAProxy is a free, very fast and reliable solution offering high
+availability, load balancing, and proxying for TCP and HTTP-based
+applications. It is particularly suited for web sites crawling under
+very high loads while needing persistence or Layer7 processing.
diff --git a/net/haproxy26/pkg-plist b/net/haproxy26/pkg-plist
new file mode 100644
index 000000000000..b919f519dccf
--- /dev/null
+++ b/net/haproxy26/pkg-plist
@@ -0,0 +1,113 @@
+man/man1/haproxy.1.gz
+sbin/halog
+sbin/haproxy
+%%PORTDOCS%%%%DOCSDIR%%/51Degrees-device-detection.txt
+%%PORTDOCS%%%%DOCSDIR%%/DeviceAtlas-device-detection.txt
+%%PORTDOCS%%%%DOCSDIR%%/SOCKS4.protocol.txt
+%%PORTDOCS%%%%DOCSDIR%%/SPOE.txt
+%%PORTDOCS%%%%DOCSDIR%%/WURFL-device-detection.txt
+%%PORTDOCS%%%%DOCSDIR%%/acl.fig
+%%PORTDOCS%%%%DOCSDIR%%/architecture.txt
+%%PORTDOCS%%%%DOCSDIR%%/close-options.txt
+%%PORTDOCS%%%%DOCSDIR%%/coding-style.txt
+%%PORTDOCS%%%%DOCSDIR%%/configuration.txt
+%%PORTDOCS%%%%DOCSDIR%%/cookie-options.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/backends-v0.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/backends.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/be-fe-changes.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/binding-possibilities.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/config-language.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/connection-reuse.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/connection-sharing.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/dynamic-buffers.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/entities-v2.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/how-it-works.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/http2.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/http_load_time.url
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/pool-debugging.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/rate-shaping.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/sess_par_sec.txt
+%%PORTDOCS%%%%DOCSDIR%%/design-thoughts/thread-group.txt
+%%PORTDOCS%%%%DOCSDIR%%/gpl.txt
+%%PORTDOCS%%%%DOCSDIR%%/haproxy.1
+%%PORTDOCS%%%%DOCSDIR%%/internals/acl.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/appctx.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/buffer-api.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/filters.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/htx-api.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/initcalls.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/ist.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/layers.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/list.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/pools.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/api/scheduler.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/body-parsing.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/connect-status.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/connection-header.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/connection-scale.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/entities-v2.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/entities.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/fd-migration.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/hashing.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/header-parser-speed.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/header-tree.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/http-cookies.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/http-docs.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/http-parsing.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/list.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/list.png
+%%PORTDOCS%%%%DOCSDIR%%/internals/listener-states.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/listener-states.png
+%%PORTDOCS%%%%DOCSDIR%%/internals/lua_socket.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/lua_socket.pdf
+%%PORTDOCS%%%%DOCSDIR%%/internals/muxes.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/muxes.pdf
+%%PORTDOCS%%%%DOCSDIR%%/internals/muxes.png
+%%PORTDOCS%%%%DOCSDIR%%/internals/muxes.svg
+%%PORTDOCS%%%%DOCSDIR%%/internals/naming.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/notes-layers.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/pattern.dia
+%%PORTDOCS%%%%DOCSDIR%%/internals/pattern.pdf
+%%PORTDOCS%%%%DOCSDIR%%/internals/polling-states.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/repartition-be-fe-fi.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/sched.fig
+%%PORTDOCS%%%%DOCSDIR%%/internals/sched.pdf
+%%PORTDOCS%%%%DOCSDIR%%/internals/sched.png
+%%PORTDOCS%%%%DOCSDIR%%/internals/sched.svg
+%%PORTDOCS%%%%DOCSDIR%%/internals/ssl_cert.dia
+%%PORTDOCS%%%%DOCSDIR%%/internals/stats-v2.txt
+%%PORTDOCS%%%%DOCSDIR%%/internals/stream-sock-states.fig
+%%PORTDOCS%%%%DOCSDIR%%/intro.txt
+%%PORTDOCS%%%%DOCSDIR%%/lgpl.txt
+%%PORTDOCS%%%%DOCSDIR%%/linux-syn-cookies.txt
+%%PORTDOCS%%%%DOCSDIR%%/lua-api/Makefile
+%%PORTDOCS%%%%DOCSDIR%%/lua-api/_static/channel.fig
+%%PORTDOCS%%%%DOCSDIR%%/lua-api/_static/channel.png
+%%PORTDOCS%%%%DOCSDIR%%/lua-api/conf.py
+%%PORTDOCS%%%%DOCSDIR%%/lua-api/index.rst
+%%PORTDOCS%%%%DOCSDIR%%/lua.txt
+%%PORTDOCS%%%%DOCSDIR%%/management.txt
+%%PORTDOCS%%%%DOCSDIR%%/netscaler-client-ip-insertion-protocol.txt
+%%PORTDOCS%%%%DOCSDIR%%/network-namespaces.txt
+%%PORTDOCS%%%%DOCSDIR%%/peers.txt
+%%PORTDOCS%%%%DOCSDIR%%/peers-v2.0.txt
+%%PORTDOCS%%%%DOCSDIR%%/proxy-protocol.txt
+%%PORTDOCS%%%%DOCSDIR%%/queuing.fig
+%%PORTDOCS%%%%DOCSDIR%%/regression-testing.txt
+%%PORTDOCS%%%%DOCSDIR%%/seamless_reload.txt
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/basic-config-edge.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/content-sw-sample.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/400.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/403.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/408.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/500.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/502.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/503.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/504.http
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/errorfiles/README
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/haproxy.init
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/option-http_proxy.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/quick-test.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/socks4.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/transparent_proxy.cfg
+%%PORTEXAMPLES%%%%EXAMPLESDIR%%/wurfl-example.cfg